#!/usr/bin/python
# _*_ encoding: 'utf-8' _*_
import hal, time
h = hal.component("pyrs")
h.newpin("run",   hal.HAL_BIT, hal.HAL_IN)
h.newpin("rxreq", hal.HAL_BIT, hal.HAL_IO)
h.newpin("rxena", hal.HAL_BIT, hal.HAL_OUT)
h.newpin("rdata", hal.HAL_U32, hal.HAL_IN)
h.newpin("txreq", hal.HAL_BIT, hal.HAL_IO)
h.newpin("txena", hal.HAL_BIT, hal.HAL_OUT)
h.newpin("xdata", hal.HAL_U32, hal.HAL_OUT)
h.ready()

NBYTES = 256

try:
    i = 0
    time.sleep(2)

    h['rxena'] = 1
    h['txena'] = 1

    t0 = time.time()
    while 1:
        time.sleep(0.005)
        if h['run']:
            if not h['txreq']:
                h['xdata'] = i & 0xff
                h['txreq'] = 1
                i += 1
                if i >= NBYTES:
                    h['run'] = 0
                    t1 = time.time()
                    print "Elapsed: %6.4f sec -- %6.0f byte/sec" % ((t1 - t0), NBYTES / (t1 - t0))
        else:
            i = 0
            t0 = time.time()

        if h['rxreq']:
            print "RX %02x" % (h['rdata'] & 0xff)
            h['rxreq'] = 0

except KeyboardInterrupt:
    raise SystemExit